<?php

add_event_handler('get_admin_plugin_menu_links', 'load_fckeditor_script');
  
function load_fckeditor_script($plugin_menu_links)
{
  global $page, $template, $conf;

  if (!isset($page['page'])) return $plugin_menu_links;

  if (!($config = unserialize($conf['FCKEditor'])))
  {
    $config = array();
  }
  $toolbar = 'Full';
  $width = '750px';
  $height = '200px';
  $areas = array();

  // Category edit
  if ($page['page'] == 'cat_modify')
  {
    $areas[] = 'comment';
    $areas[] = 'mail_content';
    $toolbar = 'Basic';
    $template->set_prefilter('categories', 'add_remove_button');
  }
  // Picture modify
  elseif ($page['page'] == 'picture_modify')
  {
    $areas[] = 'description';
    $toolbar = 'Basic';
    $template->set_prefilter('picture_modify', 'add_remove_button');
  }
  // Notification by mail
  elseif ($page['page'] == 'notification_by_mail')
  {
    $areas[] = 'send_customize_mail_content';
    $toolbar = 'Basic';
    $template->set_prefilter('notification_by_mail', 'add_remove_button');
  }
  elseif ($page['page'] == 'plugin')
  {
    $section = $_GET['section'];
    // Additional pages
    if ($section == 'AdditionalPages/admin/add_page.php')
    {
      $areas[] = 'ap_content';
      $width = '100%';
      $height = '400px';
      $template->set_prefilter('plugin_admin_content', 'add_remove_button');
    }
    // PWG Stuffs
    elseif ($section == 'PWG_Stuffs/admin/add_module.php' and $_GET['type'] == 'Personal')
    {
      $areas[] = 'personal_content';
      $width = '100%';
      $height = '250px';
      $template->set_prefilter('module_options', 'add_remove_button_stuffs');
    }
  }

  if (!empty($areas))
  {
    $head_element = '
<style type="text/css">
FORM#catModify TABLE TABLE { width: 100%; }
</style>
<script type="text/javascript" src="'.FCK_PATH.'ckeditor/ckeditor.js"></script>
<script type="text/javascript">
CKEDITOR.config.toolbar_Basic =
[
  ["Source"],["Bold","Italic","Underline"],
  ["JustifyLeft","JustifyCenter","JustifyRight","JustifyBlock"],
  ["Styles","Format","Font","FontSize"],
  ["Link","Unlink","ShowBlocks"]
];
CKEDITOR.config.width = "'.$width.'";
CKEDITOR.config.height = "'.$height.'";
CKEDITOR.config.toolbar = "'.$toolbar.'";
window.onload = function()
{
';
    foreach ($areas as $area)
    {
      if (!isset($config[$area]) or $config[$area])
      {
        $head_element .= 'CKEDITOR.replace("'.$area.'");';
      }
    }
    $head_element .= '
}

function toogleEditor(name) {
  if (typeof( CKEDITOR.instances[name] ) != "undefined") {
    CKEDITOR.instances[name].destroy();
    jQuery.post("plugins/FCKEditor/update_config.php", {area: name, status: "off"});
  } else {
    CKEDITOR.replace(name);
    jQuery.post("plugins/FCKEditor/update_config.php", {area: name, status: "on"});
  }
}
</script>';

    $template->append('head_elements', $head_element);
  }
  return $plugin_menu_links;
}

function add_remove_button($content, &$smarty)
{
  $pattern = '#(<textarea.*?name="(.*?)".*?</textarea>)#ims';
  $replacement = '$1</td></tr><tr><td></td><td><a href="#" onClick="toogleEditor(\'$2\'); return false;" style="border-bottom: none; float: right;">FCK Editor On/Off</a>';
  return preg_replace($pattern, $replacement, $content);
}

function add_remove_button_stuffs($content, &$smarty)
{
  $pattern = '#<textarea.*?</textarea>#ims';
  $replacement = '<textarea name="personal_content" id="personal_content" rows="10" cols="50" style="width:100%; height: 300px;">{$PERSONAL_CONTENT}</textarea>
<br><a href="#" onClick="toogleEditor(\'personal_content\'); return false;" style="border-bottom: none; float: right;">FCK Editor On/Off</a>';
  return preg_replace($pattern, $replacement, $content);
}

?>